summaryrefslogtreecommitdiff
path: root/bin/decode+edit+encode+stream
diff options
context:
space:
mode:
Diffstat (limited to 'bin/decode+edit+encode+stream')
-rwxr-xr-xbin/decode+edit+encode+stream33
1 files changed, 33 insertions, 0 deletions
diff --git a/bin/decode+edit+encode+stream b/bin/decode+edit+encode+stream
new file mode 100755
index 0000000..7b8a635
--- /dev/null
+++ b/bin/decode+edit+encode+stream
@@ -0,0 +1,33 @@
+#!/bin/sh
+
+set -e
+
+HOST=${1:-morla}
+if [ "$HOST" = "$(hostname --short)" ]; then
+ IP=127.0.0.1
+else
+ IP=$(host "$HOST" | grep -Po 'address \K\S+')
+fi
+
+PORT=${2:-5004}
+
+SIZE=640x360
+BITRATE=500000
+
+MOVIE=../src/omni/show0/earth.mp4
+LOGO=../../content/icon_small.png
+
+# based on http://video.stackexchange.com/a/16933
+# + codec options from http://www.webmproject.org/docs/encoder-parameters/
+# example "Real-time CBR Encoding and Streaming"
+# + Drop frames, aggressively treat as static, and use fastest cpu
+ffmpeg -threads auto -re \
+ -f lavfi -i "movie=filename=$MOVIE:loop=0, setpts=N/(FRAME_RATE*TB), scale=$SIZE" \
+ -i "$LOGO" -filter_complex 'overlay=main_w-overlay_w-20:main_h-overlay_h-20' \
+ -codec:v vp8 -quality realtime -deadline realtime -cpu-used 15 \
+ -b:v "$BITRATE" -minrate "$BITRATE" -maxrate "$BITRATE" \
+ -undershoot-pct 95 -bufsize $((6000*BITRATE/1000)) -rc_init_occupancy $((4000*BITRATE/1000)) \
+ -max-intra-rate 0 \
+ -qmin 4 -qmax 56 \
+ -static-thresh 500 -skip_threshold 50 \
+ -an -f rtp "rtp://$IP:$PORT?pkt_size=1200"